/* encoding = CP932 */
//======================================================================================
//======================================================================================
//
//
//			GLj
//
//
//======================================================================================
//======================================================================================


//======================================================================================
//	include
//======================================================================================
#include "EnemyFx.h"


//======================================================================================
//
//	RXgN^
//
//======================================================================================
CENEMYFX::CENEMYFX( float x, float y, float speed, long angle, D3DCOLOR color ) : CSPRITE( SORT_NULL )
{
	Px = x;
	Py = y;
	x1 = F(LunaMath::Cos( angle ))/65536.0f*speed;
	y1 = F(LunaMath::Sin( angle ))/65536.0f*speed;
	Color = color;
}

//======================================================================================
//
//	
//
//======================================================================================
bool CENEMYFX::Action( void )
{
	Scale = LunaMath::FlatSpeed( 12L, 0L, 30, Time );
	if ( ++Time > 30 ) return true;

	Px += x1;
	Py += y1;

	RECT src = { 736, 446, 768, 478 };
	RECT dest = { (long)Px-Scale, (long)Py-Scale, (long)Px+Scale, (long)Py+Scale };
	Sprite[4][1]->Draw( &dest, Color, &src );

	return false;
}