/* encoding = CP932 */
//======================================================================================
//======================================================================================
//
//
//			wi
//
//
//======================================================================================
//======================================================================================


//======================================================================================
//	include
//======================================================================================
#include "Scroll.h"

//======================================================================================
//
//		RXgN^
//
//======================================================================================
CSCROLL::CSCROLL( long x, long y, long u1, long v1, long u2, long v2, float speed ) : CSPRITE( SORT_NULL )
{
	Px = F(x);
	Py = F(y);

	x1 = F(u1);
	y1 = F(v1);
	x2 = F(u2);
	y2 = F(v2);

	Speed = speed;
}

//======================================================================================
//
//		
//
//======================================================================================
bool CSCROLL::Action( void )
{
	long w = (long)( x2 - x1 );
	long h = (long)( y2 - y1 );

	Px += Speed;

	// EJԂ
	if ( Speed > 0 )	{ if ( Px > w ) Px -= w; }
	else				{ if ( Px < 0 ) Px += w; }

	RECT src, dest;

	SetRect( &dest, (long)Px, (long)Py, (long)Px+w, (long)Py+h );
	SetRect( &src, (long)x1, (long)y1, (long)x2, (long)y2 );
	Sprite[0][0]->Draw( &dest, D3DCOLOR_XRGB(255,255,255), &src );

	SetRect( &dest, (long)Px-w, (long)Py, (long)Px, (long)Py+h );
	SetRect( &src, (long)x1, (long)y1, (long)x2, (long)y2 );
	Sprite[0][0]->Draw( &dest, D3DCOLOR_XRGB(255,255,255), &src );

	return bDeath;
}

