/* encoding = CP932 */
//======================================================================================
//======================================================================================
//
//
//			rbgc
//
//
//======================================================================================
//======================================================================================


//======================================================================================
//	include
//======================================================================================
#include "BitBlur.h"

//======================================================================================
//
//	RXgN^
//
//======================================================================================
CBITBLUR::CBITBLUR( float x, float y ) : CSPRITE( SORT_NULL )
{
	Px = x;
	Py = y;
}

//======================================================================================
//
//	
//
//======================================================================================
bool CBITBLUR::Action( void )
{
	long size = LunaMath::FlatSpeed( 8L, 2L, 20, Time );
	long alpha = LunaMath::FlatSpeed( 255L, 0L, 20, Time );
	if ( ++Time == 20 ) return true;

	//-------------------------------------------
	// `揈
	//-------------------------------------------
	RECT src = { 736, 446, 768, 478 };
	RECT dest = { (long)Px-size, (long)Py-size, (long)Px+size, (long)Py+size };
	Sprite[3][0]->Draw( &dest, D3DCOLOR_ARGB(alpha,255,255,255), &src );

	return false;
}