/* encoding = CP932 */
//======================================================================================
//======================================================================================
//
//
//			̓foCXǗ
//
//
//
//======================================================================================
//======================================================================================


#pragma once


//======================================================================================
// INCLUDE
//======================================================================================
#include "Base.h"


//======================================================================================
// DEFINE
//======================================================================================
#define KEY_UP		0x01
#define KEY_DOWN	0x02
#define KEY_LEFT	0x04
#define KEY_RIGHT	0x08
#define KEY_01		0x10
#define KEY_02		0x20
#define KEY_03		0x40
#define KEY_04		0x80

enum eKeyState
{
	KEYSTATE_PULL,
	KEYSTATE_PUSH,
	KEYSTATE_HOLD,
};

//======================================================================================
// CLASS
//======================================================================================
class IO
{
private:
	static unsigned char State[3];

public:
	static void RefreshKeyState( void );
	static bool GetKey( eKeyState state, long Key );
};
